﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.awaitSync = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@kitajs/common");
const deasync_1 = tslib_1.__importDefault(require("deasync"));
/** Adapted from https://www.npmjs.com/package/synchronized-promise to avoid requiring deasync every time. */
function awaitSync(promise) {
    if (!(0, common_1.isPromiseLike)(promise)) {
        return promise;
    }
    let done = false;
    let err = false;
    let res;
    promise.then(function fulfilled(r) {
        res = r;
        done = true;
    }, function rejected(e) {
        err = true;
        done = true;
        res = e;
    });
    deasync_1.default.loopWhile(function isPending() {
        return !done;
    });
    if (err) {
        throw res;
    }
    return res;
}
exports.awaitSync = awaitSync;
//# sourceMappingURL=sync.js.map